package dareka;

import java.io.IOException;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.ServerSocket;
import java.net.Socket;
import java.nio.channels.ServerSocketChannel;

public class Server {
    private Config config;

    private boolean stopped = false;

    public Server(Config config) {
        this.config = config;
    }

    public void start() throws IOException, InterruptedException {
        // use channel to make it available Socket#getChannel() for non blocking
        // I/O.
        ServerSocketChannel serverCh = ServerSocketChannel.open();

        ServerSocket serverSocket = serverCh.socket();
        serverSocket.bind(new InetSocketAddress(InetAddress.getByName(null),
                config.listenPort));

        Socket client;
        int threadCount = 0;

        while (!stopped) {
            client = serverSocket.accept();

            Logger.debug("server: accespted");

            ConnectionProcessor worker = new ConnectionProcessor(config, client);
            Thread t = new Thread(worker, "ConnectionProcessorThread"
                    + ++threadCount);
            t.start();

            Logger.debug("server: worker started");
            // t.join();
        }

    }

}
